# import random

# # Objective function to maximize
# def objective_function(x):
#     return -x**2 + 10*x

# # Hill Climbing algorithm
# def hill_climbing(step_size=0.1, max_iterations=1000):
#     # Start with a random initial solution
#     current_solution = random.uniform(0, 10)  # Start between 0 and 10
#     current_value = objective_function(current_solution)
    
#     for iteration in range(max_iterations):
#         # Generate a new neighbor solution
#         new_solution = current_solution + random.uniform(-step_size, step_size)
        
#         # Ensure the solution stays within bounds
#         new_solution = max(0, min(new_solution, 10))
        
#         # Evaluate the new solution
#         new_value = objective_function(new_solution)
        
#         # If the new solution is better, move to it
#         if new_value > current_value:
#             current_solution = new_solution
#             current_value = new_value
        
#     return current_solution, current_value

# # Run the hill climbing algorithm
# best_solution, best_value = hill_climbing()
# print(f"Best solution: {best_solution}")
# print(f"Best value: {best_value}")

# for Romania MAP
# Romania map cities and their straight-line distances (SLD) to Bucharest
sld_to_bucharest = {
    'Arad': 366, 'Bucharest': 0, 'Craiova': 160, 'Drobeta': 242, 'Eforie': 161, 
    'Fagaras': 176, 'Giurgiu': 77, 'Hirsova': 151, 'Iasi': 226, 'Lugoj': 244,
    'Mehadia': 241, 'Neamt': 234, 'Oradea': 380, 'Pitesti': 100, 'Rimnicu Vilcea': 193, 
    'Sibiu': 253, 'Timisoara': 329, 'Urziceni': 80, 'Vaslui': 199, 'Zerind': 374
}

# Romania map roads (adjacency list)
romania_map = {
    'Arad': [('Zerind', 75), ('Sibiu', 140), ('Timisoara', 118)],
    'Zerind': [('Arad', 75), ('Oradea', 71)],
    'Oradea': [('Zerind', 71), ('Sibiu', 151)],
    'Sibiu': [('Arad', 140), ('Oradea', 151), ('Fagaras', 99), ('Rimnicu Vilcea', 80)],
    'Timisoara': [('Arad', 118), ('Lugoj', 111)],
    'Lugoj': [('Timisoara', 111), ('Mehadia', 70)],
    'Mehadia': [('Lugoj', 70), ('Drobeta', 75)],
    'Drobeta': [('Mehadia', 75), ('Craiova', 120)],
    'Craiova': [('Drobeta', 120), ('Rimnicu Vilcea', 146), ('Pitesti', 138)],
    'Rimnicu Vilcea': [('Sibiu', 80), ('Craiova', 146), ('Pitesti', 97)],
    'Fagaras': [('Sibiu', 99), ('Bucharest', 211)],
    'Pitesti': [('Rimnicu Vilcea', 97), ('Craiova', 138), ('Bucharest', 101)],
    'Bucharest': [('Fagaras', 211), ('Pitesti', 101), ('Giurgiu', 90), ('Urziceni', 85)],
    'Giurgiu': [('Bucharest', 90)],
    'Urziceni': [('Bucharest', 85), ('Hirsova', 98), ('Vaslui', 142)],
    'Hirsova': [('Urziceni', 98), ('Eforie', 86)],
    'Eforie': [('Hirsova', 86)],
    'Vaslui': [('Urziceni', 142), ('Iasi', 92)],
    'Iasi': [('Vaslui', 92), ('Neamt', 87)],
    'Neamt': [('Iasi', 87)]
}

# Hill Climbing algorithm
def hill_climbing_romania(start_city, goal_city):
    current_city = start_city
    path = [current_city]

    while current_city != goal_city:
        neighbors = romania_map[current_city]
        next_city = None
        best_heuristic = float('inf')
        
        # Check all neighbors to find the one with the lowest straight-line distance to Bucharest
        for (neighbor, road_cost) in neighbors:
            if sld_to_bucharest[neighbor] < best_heuristic:
                next_city = neighbor
                best_heuristic = sld_to_bucharest[neighbor]
        
        # If no better neighbor is found, return the current path (local optimum)
        if best_heuristic >= sld_to_bucharest[current_city]:
            print("Reached local optimum, could not find a better neighbor.")
            return path
        
        # Move to the next city
        current_city = next_city
        path.append(current_city)
    
    return path

# Start the search from Arad to Bucharest
result_path = hill_climbing_romania('Arad', 'Bucharest')
print("Path found:", " -> ".join(result_path))
